//#include "ConnectingBoxes.h"
////#include "../../disjoint/DisjointSets.h"
//#include <math.h>
//
//#define BOX_DIRECTION 0
//#define BOX_WIDTH_VAR 1
//#define BOX_HEIGHT_VAR 2
//
//#define MIN_BOX_WIDTH 0.3f
//
//#define CONNECTOR_WIDTH (GRID_SIZE * 0.1f)
//
//ConnectingBoxes::ConnectingBoxes(int typeID) : Renderable3d(typeID)
//{
//}
//
//ConnectingBoxes::~ConnectingBoxes(void)
//{
//}
//
//void ConnectingBoxes::SetVariables()
//{
//	m_layerVariables[BOX_DIRECTION].Initialize(this, "Direction", 0.0f, 3.0, 0.0f);
//	m_layerVariables[BOX_WIDTH_VAR].Initialize(this, "Box width", MIN_BOX_WIDTH, GRID_SIZE - 0.3f, MIN_BOX_WIDTH);
//	m_layerVariables[BOX_HEIGHT_VAR].Initialize(this, "Box height", MIN_BOX_WIDTH, 2.0f, MIN_BOX_WIDTH);
//
//	m_variableCount = 3;
//}
//
//void ConnectingBoxes::BuildCollection()
//{
//	m_entityCollection.Clear();
//	m_layerVariables[BOX_WIDTH_VAR].PrepareDownSample(m_spaceWindow);
//	m_layerVariables[BOX_DIRECTION].PrepareDownSample(m_spaceWindow);
//	m_layerVariables[BOX_HEIGHT_VAR].PrepareDownSample(m_spaceWindow);
//
////	LOG(L"Doing again!");
//
//	//Create disjoint set
//	DisjointSets set;
//	int size_x = m_spaceWindow.GetPhysicalWidth(), size_y = m_spaceWindow.GetPhysicalHeight();
//	set.AddElements(size_x * size_y );
//
//	//iterating over space
//	for(int j = 0; j < size_y; j++)
//	{
//		for(int i = 0; i < size_x; i++)	
//		{
//			float xpos = i, ypos = j;
//			m_spaceWindow.GetWorldCoordinates(xpos, ypos);
//			//LOG(L"Translating (%d, %d) to (%g, %g)", i, j, xpos, ypos);
//
//			float boxWidth = m_layerVariables[BOX_WIDTH_VAR].GetDownSampledValue(i,j, MIN_BOX_WIDTH);
//
//			if(boxWidth > 0.0f)
//			{
//				float boxHeight = m_layerVariables[BOX_HEIGHT_VAR].GetDownSampledValue(i,j);
//				//draw this cell
//				Entity3d ent;
//				ent.Initialize(xpos, ypos, boxWidth, boxWidth, boxHeight);
//				m_entityCollection.AddEntity(ent, i, j, 0);
//
//				//get direction specified by variable, loop until all directions fail, or until a connection is made.
//				int angle = (int)DivFloat(m_layerVariables[BOX_DIRECTION].GetDownSampledValue(i,j), 1.0f);
//
//				for(int count = 0; count < 2; count++)
//				{
//					AttemptConnect(i, j, (angle + count) % 4, &set);
//				}
//			}
//		}
//	}
//}
//
//
//bool ConnectingBoxes::AttemptConnect(int i, int j, int angle, DisjointSets *set)
//{
//	//translate meaning of angle
//	int u = 0, v = 0;
//	switch(angle)
//	{
//	case 0:
//		u = 1;
//		break;
//	case 1:
//		v = 1;
//		break;
//	case 2:
//		u = -1;
//		break;
//	default:
//		v = -1;
//		break;
//	}
//
//	int size_x = m_spaceWindow.GetPhysicalWidth();
//	int size_y = m_spaceWindow.GetPhysicalHeight();
//
//	//ensure that new cell is within bounds
//	if((i + u >= size_x) || (i+u < 0)) return false;
//	if((j + v >= size_y) || (j+v < 0)) return false;
//
//	int id_current = i + size_x*j ;
//	int id_next = i + u + size_x*(j+v) ;
//
//	int next_x = i + u;
//	int next_y = j + v;
//	float nextExists = m_layerVariables[BOX_WIDTH_VAR].GetDownSampledValue(next_x,next_y, MIN_BOX_WIDTH);	
//	
//	//check and that next cell exists
//	if(nextExists > 0.0f)
//	{
//		//test if disjoint
//		int set1 = set->FindSet(id_current);
//		int set2 = set->FindSet(id_next);
//		if(set1 != set2)
//		{
//			//union disjoint sets
//			set->Union(set1, set2);
//
//			float xpos = i, ypos = j;
//			m_spaceWindow.GetWorldCoordinates(xpos, ypos);
//
//			//connector goes between
//			float con_x = xpos + GRID_SIZE * u / 2;
//			float con_y = ypos + GRID_SIZE * v / 2;
//			float con_wid = (GRID_SIZE - CONNECTOR_WIDTH)*u + CONNECTOR_WIDTH;
//			float con_hei = (GRID_SIZE - CONNECTOR_WIDTH)*v + CONNECTOR_WIDTH;
//
//			//draw connection
//			Entity3d ent;
//			ent.Initialize(con_x, con_y, con_wid, con_hei, 0.2f);
//			m_entityCollection.AddEntity(ent, i, j, 4);
//		}
//
//		//either cell has been assimilated and connected, or it already is part of the borg.
//		return true;
//	}
//
//	//target cell does not exist
//	return false;
//}