#pragma once
#include <utils.h>

enum EntityRenderedType
{
	RENDERED_NONE,
	RENDERED_CUBE
};

enum Direction
{
	NORTH,SOUTH,EAST,WEST
};

typedef struct __CONNECTIONS
{
	unsigned north	: 1; //u =  1
	unsigned east	: 1; //v = -1
	unsigned south	: 1; //u =  1
	unsigned west	: 1; //v = -1
} ConnectionStruct;

class Entity3d
{
public:

	union
	{
		ConnectionStruct Connections;
		unsigned char ConnectionsValue;
	} Connectivity;

	EntityRenderedType rendered_type;
	float xpos, ypos;
	float width, length, height;
	void Initialize(float x, float y, float w, float l, float h);

	void Render(ConnectionStruct &externalConnections);

	Entity3d(void);
	~Entity3d(void);
protected:
	void DrawFace(float yangle, float zangle = 0);
	void DrawTopAndBottom();
	void DrawSideFace(Direction dir);
};