#pragma once
#include <utils.h>
#include "Entity3d.h"
#include "../../disjoint/DisjointSets.h"


#define TEXTURE_COUNT 5

class Entity3dCollection
{
public:
	void AddEntity(Entity3d ent, int x, int y, int textureIndex = 0);
	void Clear();
	void Render(GLuint *textures, GLuint firstEntityList);
	void CompileDisplayLists(GLuint firstEntityList);

	void EnsureAdjacentConnectivity(int textureIndex);

	DisjointSets m_disjointSets[TEXTURE_COUNT];

	Entity3dCollection(void);
	~Entity3dCollection(void);
private:
	Entity3d m_entities[TEXTURE_COUNT][MAX_ENTITIES][MAX_ENTITIES];
	void DiscoverConnectedNodes(int texture, int x, int y, ConnectionStruct &connections);
	void UnionTwoNodes(int x, int y, int textureIndex, int deltax, int deltay);
	bool AreDisjoint(int x, int y, int textureIndex, int deltax, int deltay);
	void RenderSingleNode(int texture, int x, int y);
};