#include "UserPromptUtil.h"

//WINDOWS VERSION
#include "Windows.h"

#pragma(lib, "comdlg32.lib");

//internal utility function, attempts to find main GUI window of application using calling thread.
HWND GetMainWindow()
{
	GUITHREADINFO info;
	info.cbSize = sizeof(GUITHREADINFO);
	if(!GetGUIThreadInfo(NULL, &info))
		return 0;

	return info.hwndActive;
}

string UserPromptUtil::SaveFileName()
{
	char filename[1024];
	memset(filename, 0, sizeof(filename));

	OPENFILENAMEA Ofn;
	Ofn.lStructSize = sizeof(OPENFILENAMEA);
	Ofn.hwndOwner = GetMainWindow();
	Ofn.lpstrFilter = "XML Files (*.xml)\0*.xml\0All Files\0*.*\0\0";
	Ofn.lpstrFile= filename;
	Ofn.nMaxFile = sizeof(filename) / sizeof(*filename); 
	Ofn.lpstrFileTitle = NULL;
	Ofn.lpstrCustomFilter = NULL;
	Ofn.lpstrInitialDir = (LPSTR)NULL; 
	Ofn.Flags = OFN_OVERWRITEPROMPT; 
	Ofn.lpstrTitle = "ARIGHT";
	Ofn.lpstrDefExt = NULL;
	Ofn.hInstance = NULL;

	GetSaveFileNameA(&Ofn);
	return string(filename);
}

string UserPromptUtil::LoadFileName()
{
	char filename[1024];
	memset(filename, 0, sizeof(filename));

	OPENFILENAMEA Ofn;
	Ofn.lStructSize = sizeof(OPENFILENAMEA);
	Ofn.hwndOwner = GetMainWindow();
	Ofn.lpstrFilter = "XML Files (*.xml)\0*.xml\0All Files\0*.*\0\0";
	Ofn.lpstrFile= filename;
	Ofn.nMaxFile = sizeof(filename) / sizeof(*filename); 
	Ofn.lpstrFileTitle = NULL;
	Ofn.lpstrCustomFilter = NULL;
	Ofn.lpstrInitialDir = (LPSTR)NULL; 
	Ofn.Flags = OFN_OVERWRITEPROMPT; 
	Ofn.lpstrTitle = "ARIGHT";
	Ofn.lpstrDefExt = NULL;
	Ofn.hInstance = NULL;

	GetOpenFileNameA(&Ofn);
	return string(filename);
}

void UserPromptUtil::UserMessageBox(string text, string caption)
{
	//get main window
	HWND mainwnd = GetMainWindow();
	MessageBoxA(mainwnd, text.c_str(), caption.c_str(), MB_ICONINFORMATION);
}


UserPromptUtil::UserPromptUtil(void)
{
}

UserPromptUtil::~UserPromptUtil(void)
{
}

string UserPromptUtil::GetExecutablePath()
{
	char buffer[MAX_PATH];
    DWORD dwResult = GetModuleFileNameA(NULL, buffer, MAX_PATH);
	if(dwResult)
	{
		char *chop = strrchr(buffer, '\\');
#ifdef _DEBUG
		*chop = 0;
		chop = strrchr(buffer, '\\'); //perform again, go up one level
#endif
		chop++;
		*chop = 0;
		return string(buffer);
	}
	else
		return string("");
}