//util functions and structs.

#pragma once

#define DISABLE_LIBNOISE

#define _QUOTE(x) #x
#define QUOTE(x) _QUOTE(x)

#define MAX_ENTITIES 100


// [WODE]
#ifdef __APPLE__
	#include <Glut/glut.h>
	#include <Glui/glui.h>
#else
	#include <freeglut.h>
	#include <glui.h>
#endif 

#include <string.h>
using namespace std;
#include <assert.h>
#include <stdio.h>

//PI calculations courtesy of www.WolframAlpha.com :D
#define TWICE_PI	(6.2831853f)
#define PI			(3.1415926f)
#define HALF_PI		(1.5707963f)
#define FOURTH_PI	(0.7853981f)


class LayerManager;
class LayerVariable;
//class WindowMapping;
class BaseRenderable;
class Renderable3d;
class Renderable2d;

#define MAX(a,b) ((a>b)?(a):(b))
#define MIN(a,b) ((a<b)?(a):(b))

#define ABS(a) ((a<0)?(-a):(a))

#define WINDOW_WIDTH	600
#define WINDOW_HEIGHT	500

struct RECTFLOAT
{
	float left, top, right, bottom;
};

enum DisplayMode
{
	DISPLAY_2D,
	DISPLAY_3D
};

/**
* A kind of "modulo" function for floats.
* returns the remainder after dividing a by b.
*/
float ModFloat(float a, float b);

//like div for int, but returns the whole amount of a / b, in float.
float DivFloat(float a, float b);

bool FileExists( const char* FileName );

//debug helper, just drop this in anywhere.
#ifdef __APPLE__
// [WODE] can't seem to make this work on the mac atm
#define LOG(string, ...)//			wprintf(string L"\r\n", __VA_ARGS__);
#else
#define LOG(string, ...)			{WCHAR ____text[500]; _snwprintf_s(____text, 500, string L"\r\n", __VA_ARGS__); OutputDebugString(____text);}
#endif




typedef struct _POINT_FLOAT {
    float   x;
    float   y;
} POINT_FLOAT, *PPOINT_FLOAT;

// [WODE]
#ifdef __APPLE__
	#define sprintf_s sprintf
	#define strcpy_s strcpy
#endif